# Un clasificador usando árboles
import numpy as np
import sys
from sklearn import model_selection
from sklearn import tree
from sklearn import metrics

# Cargamos los datos 
X = np.loadtxt( "X.txt" ) 
y = np.loadtxt( "y.txt" ) 

# Separamos los datos de entrenamiento y de prueba
# random_state = 20
Xentrena, Xprueba, yentrena, yprueba = model_selection.train_test_split( X, y, test_size = 0.2, random_state = 20 )
# np.savetxt( "Xentrena.txt", Xentrena )
# np.savetxt( "yentrena.txt", yentrena )
# np.savetxt( "Xprueba.txt", Xprueba )
# np.savetxt( "yprueba.txt", yprueba )
n = sum( yentrena )
print( "Clase 0 = ", len( yentrena )-n )
print( "Clase 1 = ", n )

# Se usa un árbol de decisión
arbol = tree.DecisionTreeClassifier()
arbol.fit(Xentrena, yentrena)

ypredichas = arbol.predict(Xentrena)
exactitud = metrics.accuracy_score( yentrena, ypredichas )
print( "Entrenamiento:", exactitud )

ypredichas = arbol.predict( Xprueba )
e = metrics.accuracy_score( yprueba, ypredichas )
print( "Prueba:", e )

print( "Importancia de las características:" )
print( arbol.feature_importances_  )

	
a = tree.export_text( arbol, feature_names=['C1', 'C2'], max_depth=10, spacing=3, decimals=2, show_weights=True)
print( a )

try :
	arch = open( "arbol.dot", 'w' )
except:
	print( "No puedo abril el archivo de salida" )
	sys.exit(1)

# pip install graphviz
# dot -Tpng tree.dot -o tree.png
# Genera gráfica del árbol de decisión
tree.export_graphviz( arbol, out_file=arch, feature_names=['C1', 'C2'], class_names=['A', 'B' ])

